%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

Name:           ocaml-biniou
Version:        1.2.2
Release:        %mkrel 1
Summary:        Binary data format designed for speed, safety and ease of use
License:        BSD
Group:          Development/OCaml
URL:            https://github.com/ocaml-community/biniou
VCS:            git:%{url}.git
Source0:        %{url}/releases/download/%{version}/biniou-%{version}.tbz

BuildRequires:  ocaml >= 4.02.3
BuildRequires:  ocaml-camlp-streams-devel
BuildRequires:  ocaml-easy-format-devel
BuildRequires:  ocaml-ocamldoc
BuildRequires:  ocaml-dune
Requires:       ocaml-easy-format

%description
Biniou (pronounced "be new") is a binary data format designed for speed,
safety, ease of use and backward compatibility as protocols evolve. Biniou
is vastly equivalent to JSON in terms of functionality but allows
implementations several times faster (4 times faster than yojson), with
25-35% space savings.

Biniou data can be decoded into human-readable form without knowledge of
type definitions except for field and variant names which are represented by
31-bit hashes. A program named 'bdump' is provided for routine visualization
of biniou data files.

The program atdgen can be used to derive OCaml-Biniou serializers and
deserializers from type definitions.

%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}
Requires:       ocaml-camlp-streams-devel%{?_isa}
Requires:       ocaml-easy-format-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%autosetup -n biniou-%{version}


%build
%dune_build


%install
%dune_install

%ifarch %{ocaml_native_compiler}
# avoid potential future name conflict
mv $RPM_BUILD_ROOT%{_bindir}/{,ocaml-}bdump
sed -i '/bdump/d' .ofiles
%endif


%check
# Upstream doesn't know how to build the tests without ocamlopt, so:
%ifarch %{ocaml_native_compiler}
%dune_check
%endif


%files -f .ofiles
%license LICENSE
%doc README.md


%files devel -f .ofiles-devel
%license LICENSE
%doc biniou-format.txt CHANGES.md
%doc _build/install/default/doc/*
%ifarch %{ocaml_native_compiler}
%{_bindir}/ocaml-bdump
%endif


%changelog
* Fri Jun 20 2025 daviddavid <daviddavid> 1.2.2-1.mga10
+ Revision: 2193120
- new version: 1.2.2

* Thu May 19 2022 pterjan <pterjan> 1.2.1-8.mga9
+ Revision: 1859099
- Rebuild for OCaml 4.14

* Wed Mar 30 2022 umeabot <umeabot> 1.2.1-7.mga9
+ Revision: 1833673
- Mageia 9 Mass Rebuild

* Wed Oct 13 2021 tv <tv> 1.2.1-6.mga9
+ Revision: 1750863
- Rebuild for ocaml 4.13.1

* Wed Mar 03 2021 tv <tv> 1.2.1-5.mga9
+ Revision: 1697310
- rebuild for ocaml-4.2-12

* Sun Jan 10 2021 pterjan <pterjan> 1.2.1-4.mga8
+ Revision: 1670662
- Rebuild to generate ocamlx provides

* Fri Feb 28 2020 umeabot <umeabot> 1.2.1-3.mga8
+ Revision: 1551580
- Rebuild for ocaml 4.10.0 final

* Wed Feb 19 2020 umeabot <umeabot> 1.2.1-2.mga8
+ Revision: 1543714
- Mageia 8 Mass Rebuild

* Wed Jan 22 2020 tv <tv> 1.2.1-1.mga8
+ Revision: 1482139
- new release + rebuild for ocaml-4.10

* Tue Oct 23 2018 pterjan <pterjan> 1.2.0-4.mga7
+ Revision: 1324383
- Rebuild for ocaml 4.07.1

* Sun Sep 23 2018 umeabot <umeabot> 1.2.0-3.mga7
+ Revision: 1299838
- Mageia 7 Mass Rebuild

* Tue Jun 26 2018 daviddavid <daviddavid> 1.2.0-2.mga7
+ Revision: 1239762
- rebuild for new ocaml-easy-format 1.3.1

* Sun Nov 26 2017 tv <tv> 1.2.0-1.mga7
+ Revision: 1179894
- new release
- rebuild for new ocaml

* Thu Oct 12 2017 daviddavid <daviddavid> 1.0.9-6.mga7
+ Revision: 1171360
- rebuild for fixed ocaml (use standard ISO C99 types {u}uint{32,64}_t)

* Thu Nov 24 2016 neoclust <neoclust> 1.0.9-5.mga6
+ Revision: 1069785
- Rebuild against fixed ocaml

* Wed Feb 17 2016 umeabot <umeabot> 1.0.9-4.mga6
+ Revision: 963775
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 1.0.9-3.mga5
+ Revision: 744543
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.0.9-2.mga5
+ Revision: 682991
- Mageia 5 Mass Rebuild

* Tue Sep 09 2014 malo <malo> 1.0.9-1.mga5
+ Revision: 673983
- update to 1.0.9

* Sat Oct 19 2013 umeabot <umeabot> 1.0.8-4.mga4
+ Revision: 534317
- Mageia 4 Mass Rebuild

* Tue Sep 10 2013 blue_prawn <blue_prawn> 1.0.8-3.mga4
+ Revision: 477263
- rebuild for ocaml-4.01.0

* Tue Sep 10 2013 blue_prawn <blue_prawn> 1.0.8-2.mga4
+ Revision: 477245
- rebuild for ocaml-4.01.0

* Wed Jul 31 2013 blue_prawn <blue_prawn> 1.0.8-1.mga4
+ Revision: 461807
- updated to last version 1.0.8

* Sun Apr 07 2013 malo <malo> 1.0.5-5.mga3
+ Revision: 408638
- fix requires

* Sat Jan 12 2013 umeabot <umeabot> 1.0.5-4.mga3
+ Revision: 361162
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Oct 19 2012 malo <malo> 1.0.5-3.mga3
+ Revision: 308267
- rebuild for ocaml-4.0.1

* Mon Oct 01 2012 blue_prawn <blue_prawn> 1.0.5-2.mga3
+ Revision: 301637
- new rpm group for ocaml

* Fri Sep 28 2012 blue_prawn <blue_prawn> 1.0.5-1.mga3
+ Revision: 299102
- updated to last version 1.0.5
- new rpm group for ocaml
- updated to last version 1.0.5

* Sat Sep 01 2012 blue_prawn <blue_prawn> 1.0.4-1.mga3
+ Revision: 286790
- updated to last version 1.0.4

* Sun Jun 24 2012 blue_prawn <blue_prawn> 1.0.0-1.mga3
+ Revision: 263049
- added BuildRequires: ocaml-easy-format-devel
- added BuildRequires: ocaml-easy-format
- imported package ocaml-biniou

